Index: FL/Fl_Export.H
===================================================================
--- FL/Fl_Export.H	(revision 10206)
+++ FL/Fl_Export.H	(working copy)
@@ -29,6 +29,8 @@
 #    else
 #      define FL_EXPORT	__declspec(dllimport)
 #    endif /* FL_LIBRARY */
+#  elif __GNUC__ >= 4
+#    define FL_EXPORT __attribute__ ((visibility ("default")))
 #  else
 #    define FL_EXPORT
 #  endif /* FL_DLL */
Index: configure.in
===================================================================
--- configure.in	(revision 10206)
+++ configure.in	(working copy)
@@ -255,6 +255,8 @@
             IMGDSONAME="libfltk_images.so.$FL_API_VERSION"
             CAIRODSONAME="libfltk_cairo.so.$FL_API_VERSION"
             DSOCOMMAND="\$(CXX) \$(DSOFLAGS) -Wl,-soname,\$@ \$(LDLIBS) -shared -fPIC $DEBUGFLAG -o"
+            OPTIM="$OPTIM -fvisibility=hidden"
+            CXXFLAGS="$CXXFLAGS -fvisibility-inlines-hidden"
 	    if test "x$libdir" != "x/usr/lib" -a "x$libdir" != "x/usr/lib64"; then
 		    DSOLINK="-Wl,-rpath,$libdir"
             fi
Index: src/Fl_x.cxx
===================================================================
--- src/Fl_x.cxx	(revision 10206)
+++ src/Fl_x.cxx	(working copy)
@@ -36,6 +36,7 @@
 #  include <FL/Fl_Paged_Device.H>
 #  include <FL/Fl_Shared_Image.H>
 #  include <FL/fl_ask.H>
+#  include <FL/filename.H>
 #  include <stdio.h>
 #  include <stdlib.h>
 #  include "flstring.h"
Index: src/numericsort.c
===================================================================
--- src/numericsort.c	(revision 10206)
+++ src/numericsort.c	(working copy)
@@ -39,10 +39,10 @@
 #      include <ndir.h>
 #    endif /* HAVE_NDIR_H */
 #  endif /* HAVE_DIRENT_H */
-#else /* For WIN32 variants */
-#  include <FL/filename.H>
 #endif /* !WIN32 || __CYGWIN__ */
 
+#include <FL/filename.H>
+
 /*
  * 'numericsort()' - Compare two directory entries, possibly with
  *                   a case-insensitive comparison...
